<!DOCTYPE html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <title>Dashboard for /Users/yassine/Projects/gosuite/packages/base/src</title>
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link href=".css/bootstrap.min.css" rel="stylesheet" type="text/css">
  <link href=".css/nv.d3.min.css" rel="stylesheet" type="text/css">
  <link href=".css/style.css" rel="stylesheet" type="text/css">
  <link href=".css/custom.css" rel="stylesheet" type="text/css">
 </head>
 <body>
  <header>
   <div class="container-fluid">
    <div class="row">
     <div class="col-md-12">
      <nav aria-label="breadcrumb">
       <ol class="breadcrumb">
         <li class="breadcrumb-item"><a href="index.html">/Users/yassine/Projects/gosuite/packages/base/src</a></li>
         <li class="breadcrumb-item active">(Dashboard)</li>

       </ol>
      </nav>
     </div>
    </div>
   </div>
  </header>
  <div class="container-fluid">
   <div class="row">
    <div class="col-md-12">
     <h2>Classes</h2>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Coverage Distribution</h3>
     <div id="classCoverageDistribution" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Complexity</h3>
     <div id="classComplexity" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Insufficient Coverage</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Class</th>
         <th class="text-right">Coverage</th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#20">Gosuite\Base\Acquisition\BasicBindingContract</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Resource.php.html#15">Gosuite\Base\Resources\Resource</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Sellable.php.html#12">Sellable</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#10">Rentable</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/PhysicalResourceExtension.php.html#7">PhysicalResourceExtension</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/HumanResourceExtension.php.html#4">HumanResourceExtension</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/HasParent.php.html#6">HasParent</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Physical/PhysicalResource.php.html#24">Gosuite\Base\Resources\Physical\PhysicalResource</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Human/HumanResourceRole.php.html#7">Gosuite\Base\Resources\Human\HumanResourceRole</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Human/HumanResource.php.html#17">Gosuite\Base\Resources\Human\HumanResource</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Inventory/InventoryManager.php.html#21">Gosuite\Base\Inventory\InventoryManager</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Core/Action.php.html#7">Gosuite\Base\Core\Action</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="BaseServiceProvider.php.html#6">Gosuite\Base\BaseServiceProvider</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#22">Gosuite\Base\Acquisition\BasicRentContract</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseStrategy.php.html#22">Gosuite\Base\Acquisition\BasicPurchaseStrategy</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#13">Stocked</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#15">Contractable</a></td><td class="text-right">33%</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseContract.php.html#24">Gosuite\Base\Acquisition\BasicPurchaseContract</a></td><td class="text-right">42%</td></tr>

       </tbody>
      </table>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Project Risks</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Class</th>
         <th class="text-right"><abbr title="Change Risk Anti-Patterns (CRAP) Index">CRAP</abbr></th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#20">Gosuite\Base\Acquisition\BasicBindingContract</a></td><td class="text-right">812</td></tr>
       <tr><td><a href="Resources/Physical/PhysicalResource.php.html#24">Gosuite\Base\Resources\Physical\PhysicalResource</a></td><td class="text-right">210</td></tr>
       <tr><td><a href="Resources/Resource.php.html#15">Gosuite\Base\Resources\Resource</a></td><td class="text-right">210</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#15">Contractable</a></td><td class="text-right">165</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#22">Gosuite\Base\Acquisition\BasicRentContract</a></td><td class="text-right">156</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#10">Rentable</a></td><td class="text-right">156</td></tr>
       <tr><td><a href="Resources/Human/HumanResource.php.html#17">Gosuite\Base\Resources\Human\HumanResource</a></td><td class="text-right">132</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#13">Stocked</a></td><td class="text-right">90</td></tr>
       <tr><td><a href="Resources/Traits/HumanResourceExtension.php.html#4">HumanResourceExtension</a></td><td class="text-right">56</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseContract.php.html#24">Gosuite\Base\Acquisition\BasicPurchaseContract</a></td><td class="text-right">24</td></tr>
       <tr><td><a href="BaseServiceProvider.php.html#6">Gosuite\Base\BaseServiceProvider</a></td><td class="text-right">20</td></tr>

       </tbody>
      </table>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-12">
     <h2>Methods</h2>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Coverage Distribution</h3>
     <div id="methodCoverageDistribution" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Complexity</h3>
     <div id="methodComplexity" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Insufficient Coverage</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Method</th>
         <th class="text-right">Coverage</th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#27"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::bindResources">bindResources</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Resource.php.html#89"><abbr title="Gosuite\Base\Resources\Resource::contracts">contracts</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#142"><abbr title="Contractable::files">files</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#129"><abbr title="Contractable::tenants">tenants</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#102"><abbr title="Contractable::addFile">addFile</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#84"><abbr title="Contractable::getTenants">getTenants</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#74"><abbr title="Contractable::addTenant">addTenant</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#48"><abbr title="Contractable::addNestedResources">addNestedResources</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Resource.php.html#78"><abbr title="Gosuite\Base\Resources\Resource::physical">physical</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/HumanResourceExtension.php.html#8"><abbr title="HumanResourceExtension::create">create</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Resource.php.html#68"><abbr title="Gosuite\Base\Resources\Resource::human">human</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Resource.php.html#49"><abbr title="Gosuite\Base\Resources\Resource::toOrigin">toOrigin</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Resource.php.html#39"><abbr title="Gosuite\Base\Resources\Resource::type">type</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Resource.php.html#23"><abbr title="Gosuite\Base\Resources\Resource::register">register</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Physical/PhysicalResource.php.html#106"><abbr title="Gosuite\Base\Resources\Physical\PhysicalResource::tenants">tenants</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Physical/PhysicalResource.php.html#86"><abbr title="Gosuite\Base\Resources\Physical\PhysicalResource::contracts">contracts</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/HasParent.php.html#8"><abbr title="HasParent::boot">boot</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/HumanResourceExtension.php.html#15"><abbr title="HumanResourceExtension::get">get</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#40"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::bind">bind</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#99"><abbr title="Rentable::remove">remove</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#80"><abbr title="Stocked::getUnit">getUnit</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#66"><abbr title="Stocked::consumeQuantity">consumeQuantity</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#54"><abbr title="Stocked::updateQuantity">updateQuantity</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#37"><abbr title="Stocked::getQuantity">getQuantity</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#22"><abbr title="Stocked::createQuantity">createQuantity</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Sellable.php.html#22"><abbr title="Sellable::sell">sell</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#91"><abbr title="Rentable::cancelAllContracts">cancelAllContracts</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/HumanResourceExtension.php.html#22"><abbr title="HumanResourceExtension::find">find</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#81"><abbr title="Rentable::cancelContract">cancelContract</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#62"><abbr title="Rentable::isAvailable">isAvailable</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#51"><abbr title="Rentable::getTenants">getTenants</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#38"><abbr title="Rentable::addTenant">addTenant</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#17"><abbr title="Rentable::rent">rent</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/PhysicalResourceExtension.php.html#55"><abbr title="PhysicalResourceExtension::traverse">traverse</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/HumanResourceExtension.php.html#27"><abbr title="HumanResourceExtension::__get">__get</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Physical/PhysicalResource.php.html#51"><abbr title="Gosuite\Base\Resources\Physical\PhysicalResource::do">do</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Physical/PhysicalResource.php.html#41"><abbr title="Gosuite\Base\Resources\Physical\PhysicalResource::can">can</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Human/HumanResourceRole.php.html#17"><abbr title="Gosuite\Base\Resources\Human\HumanResourceRole::actions">actions</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseContract.php.html#36"><abbr title="Gosuite\Base\Acquisition\BasicPurchaseContract::withQuantities">withQuantities</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#44"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::isCancelled">isCancelled</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#35"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::cancel">cancel</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseStrategy.php.html#24"><abbr title="Gosuite\Base\Acquisition\BasicPurchaseStrategy::sell">sell</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseContract.php.html#88"><abbr title="Gosuite\Base\Acquisition\BasicPurchaseContract::getBuyer">getBuyer</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseContract.php.html#62"><abbr title="Gosuite\Base\Acquisition\BasicPurchaseContract::validate">validate</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseContract.php.html#51"><abbr title="Gosuite\Base\Acquisition\BasicPurchaseContract::setStatus">setStatus</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#170"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::rightResources">rightResources</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Human/HumanResource.php.html#84"><abbr title="Gosuite\Base\Resources\Human\HumanResource::contracts">contracts</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#165"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::leftResources">leftResources</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#161"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::getRightResources">getRightResources</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#157"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::getLeftResources">getLeftResources</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#117"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::updateResources">updateResources</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#78"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::attachResources">attachResources</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#59"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::toGenericResource">toGenericResource</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#50"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::to">to</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#53"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::isExpired">isExpired</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#66"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::hasStarted">hasStarted</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#76"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::extend">extend</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Core/Action.php.html#17"><abbr title="Gosuite\Base\Core\Action::byResource">byResource</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Human/HumanResource.php.html#76"><abbr title="Gosuite\Base\Resources\Human\HumanResource::roles">roles</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Human/HumanResource.php.html#69"><abbr title="Gosuite\Base\Resources\Human\HumanResource::removeRole">removeRole</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Human/HumanResource.php.html#62"><abbr title="Gosuite\Base\Resources\Human\HumanResource::updateRole">updateRole</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Human/HumanResource.php.html#54"><abbr title="Gosuite\Base\Resources\Human\HumanResource::assignRole">assignRole</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Human/HumanResource.php.html#42"><abbr title="Gosuite\Base\Resources\Human\HumanResource::remove">remove</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Inventory/InventoryManager.php.html#44"><abbr title="Gosuite\Base\Inventory\InventoryManager::resources">resources</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Inventory/InventoryManager.php.html#34"><abbr title="Gosuite\Base\Inventory\InventoryManager::createQuantity">createQuantity</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#88"><abbr title="Stocked::inventories">inventories</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#87"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::revise">revise</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="BaseServiceProvider.php.html#17"><abbr title="Gosuite\Base\BaseServiceProvider::registerPublishables">registerPublishables</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="BaseServiceProvider.php.html#12"><abbr title="Gosuite\Base\BaseServiceProvider::register">register</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="BaseServiceProvider.php.html#8"><abbr title="Gosuite\Base\BaseServiceProvider::boot">boot</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#109"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::areAvailable">areAvailable</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#100"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::attachedResources">attachedResources</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#21"><abbr title="Contractable::addResources">addResources</abbr></a></td><td class="text-right">55%</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#117"><abbr title="Contractable::resources">resources</abbr></a></td><td class="text-right">66%</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseContract.php.html#75"><abbr title="Gosuite\Base\Acquisition\BasicPurchaseContract::addBuyer">addBuyer</abbr></a></td><td class="text-right">75%</td></tr>

       </tbody>
      </table>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Project Risks</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Method</th>
         <th class="text-right"><abbr title="Change Risk Anti-Patterns (CRAP) Index">CRAP</abbr></th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#117"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::updateResources">updateResources</abbr></a></td><td class="text-right">90</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#78"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::attachResources">attachResources</abbr></a></td><td class="text-right">72</td></tr>
       <tr><td><a href="Resources/Physical/PhysicalResource.php.html#51"><abbr title="Gosuite\Base\Resources\Physical\PhysicalResource::do">do</abbr></a></td><td class="text-right">56</td></tr>
       <tr><td><a href="Resources/Physical/PhysicalResource.php.html#86"><abbr title="Gosuite\Base\Resources\Physical\PhysicalResource::contracts">contracts</abbr></a></td><td class="text-right">30</td></tr>
       <tr><td><a href="Resources/Human/HumanResource.php.html#84"><abbr title="Gosuite\Base\Resources\Human\HumanResource::contracts">contracts</abbr></a></td><td class="text-right">30</td></tr>
       <tr><td><a href="Resources/Resource.php.html#23"><abbr title="Gosuite\Base\Resources\Resource::register">register</abbr></a></td><td class="text-right">20</td></tr>
       <tr><td><a href="Resources/Resource.php.html#49"><abbr title="Gosuite\Base\Resources\Resource::toOrigin">toOrigin</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#129"><abbr title="Contractable::tenants">tenants</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#59"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::toGenericResource">toGenericResource</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Resources/Traits/HumanResourceExtension.php.html#27"><abbr title="HumanResourceExtension::__get">__get</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#99"><abbr title="Rentable::remove">remove</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#21"><abbr title="Contractable::addResources">addResources</abbr></a></td><td class="text-right">9</td></tr>
       <tr><td><a href="Resources/Traits/HumanResourceExtension.php.html#15"><abbr title="HumanResourceExtension::get">get</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#17"><abbr title="Rentable::rent">rent</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#38"><abbr title="Rentable::addTenant">addTenant</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Resources/Traits/Rentable.php.html#62"><abbr title="Rentable::isAvailable">isAvailable</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#22"><abbr title="Stocked::createQuantity">createQuantity</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#37"><abbr title="Stocked::getQuantity">getQuantity</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#102"><abbr title="Contractable::addFile">addFile</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#48"><abbr title="Contractable::addNestedResources">addNestedResources</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Acquisition/BasicBindingContract.php.html#40"><abbr title="Gosuite\Base\Acquisition\BasicBindingContract::bind">bind</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Resources/Resource.php.html#89"><abbr title="Gosuite\Base\Resources\Resource::contracts">contracts</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Resources/Resource.php.html#78"><abbr title="Gosuite\Base\Resources\Resource::physical">physical</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Resources/Resource.php.html#68"><abbr title="Gosuite\Base\Resources\Resource::human">human</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Resources/Human/HumanResource.php.html#42"><abbr title="Gosuite\Base\Resources\Human\HumanResource::remove">remove</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="BaseServiceProvider.php.html#17"><abbr title="Gosuite\Base\BaseServiceProvider::registerPublishables">registerPublishables</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#109"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::areAvailable">areAvailable</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#76"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::extend">extend</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#66"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::hasStarted">hasStarted</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Acquisition/BasicRentContract.php.html#53"><abbr title="Gosuite\Base\Acquisition\BasicRentContract::isExpired">isExpired</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseContract.php.html#62"><abbr title="Gosuite\Base\Acquisition\BasicPurchaseContract::validate">validate</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseContract.php.html#36"><abbr title="Gosuite\Base\Acquisition\BasicPurchaseContract::withQuantities">withQuantities</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Resources/Traits/Stocked.php.html#66"><abbr title="Stocked::consumeQuantity">consumeQuantity</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Acquisition/Contractable.php.html#117"><abbr title="Contractable::resources">resources</abbr></a></td><td class="text-right">3</td></tr>
       <tr><td><a href="Acquisition/BasicPurchaseContract.php.html#75"><abbr title="Gosuite\Base\Acquisition\BasicPurchaseContract::addBuyer">addBuyer</abbr></a></td><td class="text-right">2</td></tr>

       </tbody>
      </table>
     </div>
    </div>
   </div>
   <footer>
    <hr/>
    <p>
     <small>Generated by <a href="https://github.com/sebastianbergmann/php-code-coverage" target="_top">php-code-coverage 6.1.4</a> using <a href="https://secure.php.net/" target="_top">PHP 7.2.12</a> with <a href="https://xdebug.org/">Xdebug 2.6.1</a> and <a href="https://phpunit.de/">PHPUnit 7.4.4</a> at Mon Apr 22 12:15:25 UTC 2019.</small>
    </p>
   </footer>
  </div>
  <script src=".js/jquery.min.js" type="text/javascript"></script>
  <script src=".js/d3.min.js" type="text/javascript"></script>
  <script src=".js/nv.d3.min.js" type="text/javascript"></script>
  <script type="text/javascript">
$(document).ready(function() {
  nv.addGraph(function() {
    var chart = nv.models.multiBarChart();
    chart.tooltips(false)
      .showControls(false)
      .showLegend(false)
      .reduceXTicks(false)
      .staggerLabels(true)
      .yAxis.tickFormat(d3.format('d'));

    d3.select('#classCoverageDistribution svg')
      .datum(getCoverageDistributionData([16,0,0,0,1,1,0,0,0,0,0,1], "Class Coverage"))
      .transition().duration(500).call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  nv.addGraph(function() {
    var chart = nv.models.multiBarChart();
    chart.tooltips(false)
      .showControls(false)
      .showLegend(false)
      .reduceXTicks(false)
      .staggerLabels(true)
      .yAxis.tickFormat(d3.format('d'));

    d3.select('#methodCoverageDistribution svg')
      .datum(getCoverageDistributionData([72,0,0,0,0,0,1,1,1,0,0,3], "Method Coverage"))
      .transition().duration(500).call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  function getCoverageDistributionData(data, label) {
    var labels = [
      '0%',
      '0-10%',
      '10-20%',
      '20-30%',
      '30-40%',
      '40-50%',
      '50-60%',
      '60-70%',
      '70-80%',
      '80-90%',
      '90-100%',
      '100%'
    ];
    var values = [];
    $.each(labels, function(key) {
      values.push({x: labels[key], y: data[key]});
    });

    return [
      {
        key: label,
        values: values,
        color: "#4572A7"
      }
    ];
  }
  nv.addGraph(function() {
    var chart = nv.models.scatterChart()
      .showDistX(true)
      .showDistY(true)
      .showLegend(false)
      .forceX([0, 100]);
    chart.tooltipContent(function(graph) {
      return '<p>' + graph.point.class + '</p>';
    });

    chart.xAxis.axisLabel('Code Coverage (in percent)');
    chart.yAxis.axisLabel('Cyclomatic Complexity');

    d3.select('#classComplexity svg')
      .datum(getComplexityData([[0,28,"<a href=\"Acquisition\/BasicBindingContract.php.html#20\">Gosuite\\Base\\Acquisition\\BasicBindingContract<\/a>"],[42.857142857142854,9,"<a href=\"Acquisition\/BasicPurchaseContract.php.html#24\">Gosuite\\Base\\Acquisition\\BasicPurchaseContract<\/a>"],[0,1,"<a href=\"Acquisition\/BasicPurchaseStrategy.php.html#22\">Gosuite\\Base\\Acquisition\\BasicPurchaseStrategy<\/a>"],[0,12,"<a href=\"Acquisition\/BasicRentContract.php.html#22\">Gosuite\\Base\\Acquisition\\BasicRentContract<\/a>"],[100,0,"<a href=\"Acquisition\/ContractFile.php.html#13\">Gosuite\\Base\\Acquisition\\ContractFile<\/a>"],[0,4,"<a href=\"BaseServiceProvider.php.html#6\">Gosuite\\Base\\BaseServiceProvider<\/a>"],[0,1,"<a href=\"Core\/Action.php.html#7\">Gosuite\\Base\\Core\\Action<\/a>"],[0,2,"<a href=\"Inventory\/InventoryManager.php.html#21\">Gosuite\\Base\\Inventory\\InventoryManager<\/a>"],[0,11,"<a href=\"Resources\/Human\/HumanResource.php.html#17\">Gosuite\\Base\\Resources\\Human\\HumanResource<\/a>"],[0,1,"<a href=\"Resources\/Human\/HumanResourceRole.php.html#7\">Gosuite\\Base\\Resources\\Human\\HumanResourceRole<\/a>"],[0,14,"<a href=\"Resources\/Physical\/PhysicalResource.php.html#24\">Gosuite\\Base\\Resources\\Physical\\PhysicalResource<\/a>"],[0,14,"<a href=\"Resources\/Resource.php.html#15\">Gosuite\\Base\\Resources\\Resource<\/a>"],[33.33333333333333,22,"<a href=\"Acquisition\/Contractable.php.html#15\">Contractable<\/a>"],[0,1,"<a href=\"Resources\/Traits\/HasParent.php.html#6\">HasParent<\/a>"],[0,7,"<a href=\"Resources\/Traits\/HumanResourceExtension.php.html#4\">HumanResourceExtension<\/a>"],[0,1,"<a href=\"Resources\/Traits\/PhysicalResourceExtension.php.html#7\">PhysicalResourceExtension<\/a>"],[0,12,"<a href=\"Resources\/Traits\/Rentable.php.html#10\">Rentable<\/a>"],[0,1,"<a href=\"Resources\/Traits\/Sellable.php.html#12\">Sellable<\/a>"],[0,9,"<a href=\"Resources\/Traits\/Stocked.php.html#13\">Stocked<\/a>"]], 'Class Complexity'))
      .transition()
      .duration(500)
      .call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  nv.addGraph(function() {
    var chart = nv.models.scatterChart()
      .showDistX(true)
      .showDistY(true)
      .showLegend(false)
      .forceX([0, 100]);
    chart.tooltipContent(function(graph) {
      return '<p>' + graph.point.class + '</p>';
    });

    chart.xAxis.axisLabel('Code Coverage (in percent)');
    chart.yAxis.axisLabel('Method Complexity');

    d3.select('#methodComplexity svg')
      .datum(getComplexityData([[0,1,"<a href=\"Acquisition\/BasicBindingContract.php.html#27\">Gosuite\\Base\\Acquisition\\BasicBindingContract::bindResources<\/a>"],[0,2,"<a href=\"Acquisition\/BasicBindingContract.php.html#40\">Gosuite\\Base\\Acquisition\\BasicBindingContract::bind<\/a>"],[0,1,"<a href=\"Acquisition\/BasicBindingContract.php.html#50\">Gosuite\\Base\\Acquisition\\BasicBindingContract::to<\/a>"],[0,3,"<a href=\"Acquisition\/BasicBindingContract.php.html#59\">Gosuite\\Base\\Acquisition\\BasicBindingContract::toGenericResource<\/a>"],[0,8,"<a href=\"Acquisition\/BasicBindingContract.php.html#78\">Gosuite\\Base\\Acquisition\\BasicBindingContract::attachResources<\/a>"],[0,9,"<a href=\"Acquisition\/BasicBindingContract.php.html#117\">Gosuite\\Base\\Acquisition\\BasicBindingContract::updateResources<\/a>"],[0,1,"<a href=\"Acquisition\/BasicBindingContract.php.html#157\">Gosuite\\Base\\Acquisition\\BasicBindingContract::getLeftResources<\/a>"],[0,1,"<a href=\"Acquisition\/BasicBindingContract.php.html#161\">Gosuite\\Base\\Acquisition\\BasicBindingContract::getRightResources<\/a>"],[0,1,"<a href=\"Acquisition\/BasicBindingContract.php.html#165\">Gosuite\\Base\\Acquisition\\BasicBindingContract::leftResources<\/a>"],[0,1,"<a href=\"Acquisition\/BasicBindingContract.php.html#170\">Gosuite\\Base\\Acquisition\\BasicBindingContract::rightResources<\/a>"],[0,2,"<a href=\"Acquisition\/BasicPurchaseContract.php.html#36\">Gosuite\\Base\\Acquisition\\BasicPurchaseContract::withQuantities<\/a>"],[0,1,"<a href=\"Acquisition\/BasicPurchaseContract.php.html#51\">Gosuite\\Base\\Acquisition\\BasicPurchaseContract::setStatus<\/a>"],[0,2,"<a href=\"Acquisition\/BasicPurchaseContract.php.html#62\">Gosuite\\Base\\Acquisition\\BasicPurchaseContract::validate<\/a>"],[75,2,"<a href=\"Acquisition\/BasicPurchaseContract.php.html#75\">Gosuite\\Base\\Acquisition\\BasicPurchaseContract::addBuyer<\/a>"],[0,1,"<a href=\"Acquisition\/BasicPurchaseContract.php.html#88\">Gosuite\\Base\\Acquisition\\BasicPurchaseContract::getBuyer<\/a>"],[100,1,"<a href=\"Acquisition\/BasicPurchaseContract.php.html#103\">Gosuite\\Base\\Acquisition\\BasicPurchaseContract::createContract<\/a>"],[0,1,"<a href=\"Acquisition\/BasicPurchaseStrategy.php.html#24\">Gosuite\\Base\\Acquisition\\BasicPurchaseStrategy::sell<\/a>"],[0,1,"<a href=\"Acquisition\/BasicRentContract.php.html#35\">Gosuite\\Base\\Acquisition\\BasicRentContract::cancel<\/a>"],[0,1,"<a href=\"Acquisition\/BasicRentContract.php.html#44\">Gosuite\\Base\\Acquisition\\BasicRentContract::isCancelled<\/a>"],[0,2,"<a href=\"Acquisition\/BasicRentContract.php.html#53\">Gosuite\\Base\\Acquisition\\BasicRentContract::isExpired<\/a>"],[0,2,"<a href=\"Acquisition\/BasicRentContract.php.html#66\">Gosuite\\Base\\Acquisition\\BasicRentContract::hasStarted<\/a>"],[0,2,"<a href=\"Acquisition\/BasicRentContract.php.html#76\">Gosuite\\Base\\Acquisition\\BasicRentContract::extend<\/a>"],[0,1,"<a href=\"Acquisition\/BasicRentContract.php.html#87\">Gosuite\\Base\\Acquisition\\BasicRentContract::revise<\/a>"],[0,1,"<a href=\"Acquisition\/BasicRentContract.php.html#100\">Gosuite\\Base\\Acquisition\\BasicRentContract::attachedResources<\/a>"],[0,2,"<a href=\"Acquisition\/BasicRentContract.php.html#109\">Gosuite\\Base\\Acquisition\\BasicRentContract::areAvailable<\/a>"],[0,1,"<a href=\"BaseServiceProvider.php.html#8\">Gosuite\\Base\\BaseServiceProvider::boot<\/a>"],[0,1,"<a href=\"BaseServiceProvider.php.html#12\">Gosuite\\Base\\BaseServiceProvider::register<\/a>"],[0,2,"<a href=\"BaseServiceProvider.php.html#17\">Gosuite\\Base\\BaseServiceProvider::registerPublishables<\/a>"],[0,1,"<a href=\"Core\/Action.php.html#17\">Gosuite\\Base\\Core\\Action::byResource<\/a>"],[0,1,"<a href=\"Inventory\/InventoryManager.php.html#34\">Gosuite\\Base\\Inventory\\InventoryManager::createQuantity<\/a>"],[0,1,"<a href=\"Inventory\/InventoryManager.php.html#44\">Gosuite\\Base\\Inventory\\InventoryManager::resources<\/a>"],[0,2,"<a href=\"Resources\/Human\/HumanResource.php.html#42\">Gosuite\\Base\\Resources\\Human\\HumanResource::remove<\/a>"],[0,1,"<a href=\"Resources\/Human\/HumanResource.php.html#54\">Gosuite\\Base\\Resources\\Human\\HumanResource::assignRole<\/a>"],[0,1,"<a href=\"Resources\/Human\/HumanResource.php.html#62\">Gosuite\\Base\\Resources\\Human\\HumanResource::updateRole<\/a>"],[0,1,"<a href=\"Resources\/Human\/HumanResource.php.html#69\">Gosuite\\Base\\Resources\\Human\\HumanResource::removeRole<\/a>"],[0,1,"<a href=\"Resources\/Human\/HumanResource.php.html#76\">Gosuite\\Base\\Resources\\Human\\HumanResource::roles<\/a>"],[0,5,"<a href=\"Resources\/Human\/HumanResource.php.html#84\">Gosuite\\Base\\Resources\\Human\\HumanResource::contracts<\/a>"],[0,1,"<a href=\"Resources\/Human\/HumanResourceRole.php.html#17\">Gosuite\\Base\\Resources\\Human\\HumanResourceRole::actions<\/a>"],[0,1,"<a href=\"Resources\/Physical\/PhysicalResource.php.html#41\">Gosuite\\Base\\Resources\\Physical\\PhysicalResource::can<\/a>"],[0,7,"<a href=\"Resources\/Physical\/PhysicalResource.php.html#51\">Gosuite\\Base\\Resources\\Physical\\PhysicalResource::do<\/a>"],[0,5,"<a href=\"Resources\/Physical\/PhysicalResource.php.html#86\">Gosuite\\Base\\Resources\\Physical\\PhysicalResource::contracts<\/a>"],[0,1,"<a href=\"Resources\/Physical\/PhysicalResource.php.html#106\">Gosuite\\Base\\Resources\\Physical\\PhysicalResource::tenants<\/a>"],[0,4,"<a href=\"Resources\/Resource.php.html#23\">Gosuite\\Base\\Resources\\Resource::register<\/a>"],[0,1,"<a href=\"Resources\/Resource.php.html#39\">Gosuite\\Base\\Resources\\Resource::type<\/a>"],[0,3,"<a href=\"Resources\/Resource.php.html#49\">Gosuite\\Base\\Resources\\Resource::toOrigin<\/a>"],[0,2,"<a href=\"Resources\/Resource.php.html#68\">Gosuite\\Base\\Resources\\Resource::human<\/a>"],[0,2,"<a href=\"Resources\/Resource.php.html#78\">Gosuite\\Base\\Resources\\Resource::physical<\/a>"],[0,2,"<a href=\"Resources\/Resource.php.html#89\">Gosuite\\Base\\Resources\\Resource::contracts<\/a>"],[55.55555555555556,6,"<a href=\"Acquisition\/Contractable.php.html#21\">Contractable::addResources<\/a>"],[0,2,"<a href=\"Acquisition\/Contractable.php.html#48\">Contractable::addNestedResources<\/a>"],[100,2,"<a href=\"Acquisition\/Contractable.php.html#61\">Contractable::saveResource<\/a>"],[0,1,"<a href=\"Acquisition\/Contractable.php.html#74\">Contractable::addTenant<\/a>"],[0,1,"<a href=\"Acquisition\/Contractable.php.html#84\">Contractable::getTenants<\/a>"],[100,1,"<a href=\"Acquisition\/Contractable.php.html#94\">Contractable::hasResources<\/a>"],[0,2,"<a href=\"Acquisition\/Contractable.php.html#102\">Contractable::addFile<\/a>"],[66.66666666666666,3,"<a href=\"Acquisition\/Contractable.php.html#117\">Contractable::resources<\/a>"],[0,3,"<a href=\"Acquisition\/Contractable.php.html#129\">Contractable::tenants<\/a>"],[0,1,"<a href=\"Acquisition\/Contractable.php.html#142\">Contractable::files<\/a>"],[0,1,"<a href=\"Resources\/Traits\/HasParent.php.html#8\">HasParent::boot<\/a>"],[0,1,"<a href=\"Resources\/Traits\/HumanResourceExtension.php.html#8\">HumanResourceExtension::create<\/a>"],[0,2,"<a href=\"Resources\/Traits\/HumanResourceExtension.php.html#15\">HumanResourceExtension::get<\/a>"],[0,1,"<a href=\"Resources\/Traits\/HumanResourceExtension.php.html#22\">HumanResourceExtension::find<\/a>"],[0,3,"<a href=\"Resources\/Traits\/HumanResourceExtension.php.html#27\">HumanResourceExtension::__get<\/a>"],[0,1,"<a href=\"Resources\/Traits\/PhysicalResourceExtension.php.html#55\">PhysicalResourceExtension::traverse<\/a>"],[0,2,"<a href=\"Resources\/Traits\/Rentable.php.html#17\">Rentable::rent<\/a>"],[0,2,"<a href=\"Resources\/Traits\/Rentable.php.html#38\">Rentable::addTenant<\/a>"],[0,1,"<a href=\"Resources\/Traits\/Rentable.php.html#51\">Rentable::getTenants<\/a>"],[0,2,"<a href=\"Resources\/Traits\/Rentable.php.html#62\">Rentable::isAvailable<\/a>"],[0,1,"<a href=\"Resources\/Traits\/Rentable.php.html#81\">Rentable::cancelContract<\/a>"],[0,1,"<a href=\"Resources\/Traits\/Rentable.php.html#91\">Rentable::cancelAllContracts<\/a>"],[0,3,"<a href=\"Resources\/Traits\/Rentable.php.html#99\">Rentable::remove<\/a>"],[0,1,"<a href=\"Resources\/Traits\/Sellable.php.html#22\">Sellable::sell<\/a>"],[0,2,"<a href=\"Resources\/Traits\/Stocked.php.html#22\">Stocked::createQuantity<\/a>"],[0,2,"<a href=\"Resources\/Traits\/Stocked.php.html#37\">Stocked::getQuantity<\/a>"],[0,1,"<a href=\"Resources\/Traits\/Stocked.php.html#54\">Stocked::updateQuantity<\/a>"],[0,2,"<a href=\"Resources\/Traits\/Stocked.php.html#66\">Stocked::consumeQuantity<\/a>"],[0,1,"<a href=\"Resources\/Traits\/Stocked.php.html#80\">Stocked::getUnit<\/a>"],[0,1,"<a href=\"Resources\/Traits\/Stocked.php.html#88\">Stocked::inventories<\/a>"]], 'Method Complexity'))
      .transition()
      .duration(500)
      .call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  function getComplexityData(data, label) {
    var values = [];
    $.each(data, function(key) {
      var value = Math.round(data[key][0]*100) / 100;
      values.push({
        x: value,
        y: data[key][1],
        class: data[key][2],
        size: 0.05,
        shape: 'diamond'
      });
    });

    return [
      {
        key: label,
        values: values,
        color: "#4572A7"
      }
    ];
  }
});
  </script>
 </body>
</html>
